// Catter.cpp : Implementation of CCatter
#include "stdafx.h"
#include "StrCat.h"
#include "Catter.h"

#include <comutil.h>

using namespace std;

typedef vector<wstring> wsvec;

/////////////////////////////////////////////////////////////////////////////
// CCatter

STDMETHODIMP CCatter::Cat(BSTR strToAdd)
{
	// Add the latest string to the vector o' strings.
	wstring str_to_add = strToAdd;
	m_totalLength += str_to_add.length();
	m_strs.push_back(str_to_add);

	return S_OK;
}

STDMETHODIMP CCatter::Resolve(BSTR* pStrOutput)
{
	// Reserve space in the final string.
	wstring final_str;
	final_str.reserve(m_totalLength);

	// Add to the final string.
	{
		for (wsvec::const_iterator i = m_strs.begin(); i < m_strs.end(); ++i)
		{
			final_str += *i;
		}
	}

	// Compute the final BSTR value and set the output.
	*pStrOutput = SysAllocString(final_str.c_str());

	return S_OK;
}

STDMETHODIMP CCatter::Reset()
{
	// Dump the contents of this.
	m_strs = wsvec();
	m_totalLength = 0;
	return S_OK;
}

STDMETHODIMP CCatter::get_Length(int* pVal)
{
    // Set the length property.
    *pVal = m_totalLength;
	return S_OK;
}

STDMETHODIMP CCatter::Prepend(BSTR strToPrepend)
{
	// Add the latest string to the vector o' strings.
	wstring str_to_add = strToPrepend;
	m_totalLength += str_to_add.length();
	m_strs.insert(m_strs.begin(), str_to_add);

	return S_OK;
}

STDMETHODIMP CCatter::Surround(BSTR strToPrepend, BSTR strToAppend)
{
    // Prepend then cat.
    m_strs.reserve(m_strs.size() + 2);
    Prepend(strToPrepend);
    Cat(strToAppend);

	return S_OK;
}

STDMETHODIMP CCatter::Dump(BSTR* pStrOutput)
{
    // Resolve then reset.
    Resolve(pStrOutput);
    Reset();

	return S_OK;
}

STDMETHODIMP CCatter::Append(BSTR strToAdd)
{
    // Cat.
    Cat(strToAdd);

	return S_OK;
}
