// Catter.h : Declaration of the CCatter

#ifndef __CATTER_H_
#define __CATTER_H_

#include "resource.h"       // main symbols

#include <string>
#include <vector>

/////////////////////////////////////////////////////////////////////////////
// CCatter
class ATL_NO_VTABLE CCatter : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCatter, &CLSID_Catter>,
	public IDispatchImpl<ICatter, &IID_ICatter, &LIBID_STRCATLib>
{
public:
	CCatter()
		: m_totalLength(0)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CATTER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCatter)
	COM_INTERFACE_ENTRY(ICatter)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ICatter
public:
	STDMETHOD(Append)(/*[in]*/ BSTR strToAdd);
	STDMETHOD(Dump)(/*[out, retval]*/ BSTR* pStrOutput);
	STDMETHOD(Surround)(/*[in]*/ BSTR strToPrepend, /*[in]*/ BSTR strToAppend);
	STDMETHOD(Prepend)(/*[in]*/ BSTR strToPrepend);
	STDMETHOD(get_Length)(/*[out, retval]*/ int *pVal);
	STDMETHOD(Reset)();
	STDMETHOD(Resolve)(/*[out, retval]*/ BSTR* pStrOutput);
	STDMETHOD(Cat)(/*[in]*/ BSTR strToAdd);

private:
	std::vector<std::wstring> m_strs;
	int m_totalLength;
};

#endif //__CATTER_H_
